package com.xk72.charles.gui.lib;

import com.xk72.charles.gui.lib.TVov;
import com.xk72.charles.gui.lib.UIUtils;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.TabbedPaneUI;
import javax.swing.plaf.basic.BasicTabbedPaneUI;

public class ScopeBarTabbedPaneUI extends BasicTabbedPaneUI {

   private static String FwRs;
   private static String GSXJ;
   private Color InuZ;
   private Color Gwbn;
   private Color Wczh;
   private Color KRBh;
   private Color VdwQ;
   private Color hndF;
   private Color eOaK;
   private Color HliR;
   private Color qkXP;
   private Color Pbhj;
   private Color WDwv;
   private Color ZcdI;
   private Color rMou;
   private Color uHxD;
   private Color PvrW;
   private static final int BMni = 1;


   public static ComponentUI createUI(JComponent var0) {
      return new ScopeBarTabbedPaneUI();
   }

   public static void main(String[] var0) {
      JFrame var3 = new JFrame("Scope Bar Tabbed Pane UI");
      JTabbedPane var1;
      (var1 = new JTabbedPane(3)).putClientProperty("ScopeBar.tabStyle", "attached");
      var1.setBackground(Color.pink);
      var1.setOpaque(true);
      var1.setUI((TabbedPaneUI)createUI(var1));
      JPanel var2;
      (var2 = new JPanel()).setBackground(Color.white);
      var1.add("Long Label", var2);
      (var2 = new JPanel()).setBackground(Color.red);
      var1.add("P2", var2);
      (var2 = new JPanel()).setOpaque(false);
      var1.add("P3", var2);
      var3.getContentPane().add(var1, "Center");
      var3.setBounds(0, 0, 500, 500);
      var3.setVisible(true);
   }

   protected void paintContentBorder(Graphics var1, int var2, int var3) {
   }

   protected void paintTabArea(Graphics var1, int var2, int var3) {
      int var7;
      int var9;
      int var15;
      if(this.tabPane.isOpaque()) {
         int var6 = this.tabPane.getWidth();
         var7 = this.tabPane.getHeight();
         Insets var8 = this.tabPane.getInsets();
         int var5;
         int var10;
         int var11;
         switch(var2) {
         case 2:
            var9 = var8.left;
            var10 = var8.top;
            var11 = this.calculateTabAreaWidth(var2, this.runCount, this.maxTabWidth);
            var5 = var7;
            ((Graphics2D)var1).setPaint(new GradientPaint((float)var9, (float)var10, this.hndF(), (float)(var9 + var11), (float)var10, this.VdwQ()));
            break;
         case 3:
            var9 = var8.left;
            var11 = var6;
            var5 = this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
            var10 = var7 - var8.bottom - var5;
            ((Graphics2D)var1).setPaint(new GradientPaint((float)var9, (float)var10, this.VdwQ(), (float)var9, (float)(var10 + var5), this.hndF()));
            break;
         case 4:
            var10 = var8.top;
            var11 = this.calculateTabAreaWidth(var2, this.runCount, this.maxTabWidth);
            var9 = var6 - var8.right - var11;
            var5 = var7;
            ((Graphics2D)var1).setPaint(new GradientPaint((float)var9, (float)var10, this.VdwQ(), (float)(var9 + var11), (float)var10, this.hndF()));
            break;
         default:
            var9 = var8.left;
            var10 = var8.top;
            var11 = var6;
            var5 = this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
            ((Graphics2D)var1).setPaint(new GradientPaint((float)var9, (float)var10, this.hndF(), (float)var9, (float)(var10 + var5), this.VdwQ()));
         }

         Rectangle var12;
         var6 = Math.max((var12 = var1.getClipBounds()).x, var8.left);
         var7 = Math.max(var12.y, var8.top);
         var15 = Math.min(var12.x + var12.width, var9 + var11);
         var3 = Math.min(var12.y + var12.height, var10 + var5);
         var1.fillRect(var6, var7, var15 - var6, var3 - var7);
      }

      var3 = this.tabPane.getTabCount();
      Rectangle var4 = new Rectangle();
      Rectangle var13 = new Rectangle();
      Rectangle var14 = var1.getClipBounds();

      for(var7 = this.runCount - 1; var7 >= 0; --var7) {
         var15 = this.tabRuns[var7];
         int var10001 = var7 == this.runCount - 1?0:var7 + 1;
         int var10000 = this.tabRuns[var7 == this.runCount - 1?0:var7 + 1];
         var9 = this.tabRuns[var10001];
         var9 = var10000 != 0?var9 - 1:var3 - 1;

         for(var15 = var15; var15 <= var9; ++var15) {
            if(this.rects[var15].intersects(var14)) {
               this.paintTab(var1, var2, this.rects, var15, var4, var13);
            }
         }
      }

   }

   private void FwRs(Graphics var1, int var2) {
      int var3 = this.tabPane.getWidth();
      int var4 = this.tabPane.getHeight();
      Insets var5 = this.tabPane.getInsets();
      int var6;
      int var7;
      int var8;
      switch(var2) {
      case 2:
         var6 = var5.left;
         var7 = var5.top;
         var8 = this.calculateTabAreaWidth(var2, this.runCount, this.maxTabWidth);
         var2 = var4;
         ((Graphics2D)var1).setPaint(new GradientPaint((float)var6, (float)var7, this.hndF(), (float)(var6 + var8), (float)var7, this.VdwQ()));
         break;
      case 3:
         var6 = var5.left;
         var8 = var3;
         var2 = this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
         var7 = var4 - var5.bottom - var2;
         ((Graphics2D)var1).setPaint(new GradientPaint((float)var6, (float)var7, this.VdwQ(), (float)var6, (float)(var7 + var2), this.hndF()));
         break;
      case 4:
         var7 = var5.top;
         var8 = this.calculateTabAreaWidth(var2, this.runCount, this.maxTabWidth);
         var6 = var3 - var5.right - var8;
         var2 = var4;
         ((Graphics2D)var1).setPaint(new GradientPaint((float)var6, (float)var7, this.VdwQ(), (float)(var6 + var8), (float)var7, this.hndF()));
         break;
      default:
         var6 = var5.left;
         var7 = var5.top;
         var8 = var3;
         var2 = this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
         ((Graphics2D)var1).setPaint(new GradientPaint((float)var6, (float)var7, this.hndF(), (float)var6, (float)(var7 + var2), this.VdwQ()));
      }

      Rectangle var10;
      var4 = Math.max((var10 = var1.getClipBounds()).x, var5.left);
      int var9 = Math.max(var10.y, var5.top);
      var6 = Math.min(var10.x + var10.width, var6 + var8);
      var2 = Math.min(var10.y + var10.height, var7 + var2);
      var1.fillRect(var4, var9, var6 - var4, var2 - var9);
   }

   protected void paintTab(Graphics var1, int var2, Rectangle[] var3, int var4, Rectangle var5, Rectangle var6) {
      Rectangle var19 = var3[var4];
      int var7;
      boolean var8 = (var7 = this.tabPane.getSelectedIndex()) == var4;
      String var9 = this.tabPane.getTitleAt(var4);
      Font var12;
      Font var10 = (var12 = this.tabPane.getFont()).getFamily().startsWith(".System")?new Font(var12.getSize(), 0, var12.getSize()):var12;
      FontMetrics var11 = var1.getFontMetrics(var10);
      Icon var23 = this.getIconForTab(var4);
      this.layoutLabel(var2, var11, var4, var9, var23, var19, var5, var6, var8);
      if(this.tabPane.getTabComponentAt(var4) == null) {
         String var21 = var9;
         ((Graphics2D)var1).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
         UIUtils.FwRs((Graphics2D)((Graphics2D)var1));
         boolean var22 = this.getRolloverTab() == var4;
         if(var8) {
            var1.setColor(UIUtils.GSXJ((JComponent)this.tabPane)?(TVov.FwRs(this.tabPane)?this.Pbhj:this.qkXP):this.WDwv);
         } else if(var22) {
            var1.setColor(this.HliR);
         }

         if(var8 || var22) {
            ((Graphics2D)var1).fillRoundRect(var19.x, var19.y, var19.width - 2, var19.height, 8, 8);
            boolean var10000;
            if(!"attached".equals(this.tabPane.getClientProperty("ScopeBar.tabStyle"))) {
               var10000 = false;
            } else {
               Component var13;
               if((var13 = this.tabPane.getSelectedComponent()) != null && var13.getBackground() != null) {
                  Color var14 = var13.getBackground();
                  var10000 = this.tabPane.isOpaque() || !var14.equals(this.tabPane.getBackground());
               } else {
                  var10000 = true;
               }
            }

            if(var10000) {
               Rectangle var24 = var19;
               int var20 = this.tabPane.getHeight();
               Insets var15 = this.tabPane.getInsets();
               Rectangle var25;
               switch(var2) {
               case 2:
                  var25 = new Rectangle(var15.left, var24.y, var24.x + 8, var24.height);
                  break;
               case 3:
                  int var16 = var20 - var15.bottom - this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
                  var25 = new Rectangle(var24.x, var16, var24.width - 2, var24.y + 8 - var16);
                  break;
               case 4:
                  var25 = new Rectangle(var24.x + var24.width - 8, var24.y, this.calculateTabAreaWidth(var2, this.runCount, this.maxTabHeight) - var15.right - (var24.x + var24.width - 8), var24.height);
                  break;
               default:
                  var25 = new Rectangle(var24.x, var24.y + var24.height - 8, var24.width - 2, this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight) - var15.bottom - (var24.y + var24.height - 8));
               }

               var19 = var25;
               if(var7 != -1) {
                  var1.fillRect(var19.x, var19.y + 1, var19.width, var19.height - 1);
               } else {
                  var1.fillRect(var19.x, var19.y, var19.width, var19.height);
               }

               if(var8 && var2 == 3) {
                  Insets var17 = this.tabPane.getInsets();
                  var1.fillRect(var17.left, var19.y, this.tabPane.getWidth() - var17.right - var17.left, 1);
               }
            }
         }

         var1.setFont(var10);
         if(this.tabPane.isEnabled() && this.tabPane.isEnabledAt(var4)) {
            Color var18 = var8?(UIUtils.GSXJ((JComponent)this.tabPane)?this.KRBh:this.eOaK):(var22?this.Wczh:(TVov.FwRs(this.tabPane)?(UIUtils.GSXJ((JComponent)this.tabPane)?this.Gwbn:this.hndF):(UIUtils.GSXJ((JComponent)this.tabPane)?this.InuZ:this.VdwQ)));
            var1.setColor(var18);
            var1.drawString(var21, var6.x, var6.y + var11.getAscent());
            return;
         }

         var1.setColor(this.tabPane.getBackgroundAt(var4).brighter());
         var1.drawString(var21, var6.x, var6.y + var11.getAscent());
         var1.setColor(this.tabPane.getBackgroundAt(var4).darker());
         var1.drawString(var21, var6.x - 1, var6.y + var11.getAscent() - 1);
      }

   }

   private static Font FwRs(Font var0) {
      return var0.getFamily().startsWith(".System")?new Font(var0.getSize(), 0, var0.getSize()):var0;
   }

   private Rectangle FwRs(Rectangle var1, int var2) {
      int var3 = this.tabPane.getHeight();
      Insets var4 = this.tabPane.getInsets();
      switch(var2) {
      case 2:
         return new Rectangle(var4.left, var1.y, var1.x + 8, var1.height);
      case 3:
         var2 = var3 - var4.bottom - this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
         return new Rectangle(var1.x, var2, var1.width - 2, var1.y + 8 - var2);
      case 4:
         return new Rectangle(var1.x + var1.width - 8, var1.y, this.calculateTabAreaWidth(var2, this.runCount, this.maxTabHeight) - var4.right - (var1.x + var1.width - 8), var1.height);
      default:
         return new Rectangle(var1.x, var1.y + var1.height - 8, var1.width - 2, this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight) - var4.bottom - (var1.y + var1.height - 8));
      }
   }

   private Rectangle FwRs(int var1) {
      int var2 = this.tabPane.getWidth();
      int var3 = this.tabPane.getHeight();
      Insets var4 = this.tabPane.getInsets();
      switch(var1) {
      case 2:
         return new Rectangle(var4.left, var4.top, this.calculateTabAreaWidth(var1, this.runCount, this.maxTabHeight), var3 - var4.top - var4.bottom);
      case 3:
         var1 = this.calculateTabAreaHeight(var1, this.runCount, this.maxTabHeight);
         var3 = var3 - var4.bottom - var1;
         return new Rectangle(var4.left, var3, var2 - var4.right - var4.left, var1);
      case 4:
         var1 = this.calculateTabAreaWidth(var1, this.runCount, this.maxTabHeight);
         return new Rectangle(var2 - var4.right - var1, var4.top, var1, var3 - var4.top - var4.bottom);
      default:
         var1 = this.calculateTabAreaHeight(var1, this.runCount, this.maxTabHeight);
         return new Rectangle(var4.left, var4.top, var2 - var4.right - var4.left, var1);
      }
   }

   private boolean FwRs() {
      if(!"attached".equals(this.tabPane.getClientProperty("ScopeBar.tabStyle"))) {
         return false;
      } else {
         Component var1;
         if((var1 = this.tabPane.getSelectedComponent()) != null && var1.getBackground() != null) {
            Color var2 = var1.getBackground();
            return this.tabPane.isOpaque() || !var2.equals(this.tabPane.getBackground());
         } else {
            return true;
         }
      }
   }

   protected int getTabLabelShiftX(int var1, int var2, boolean var3) {
      return 0;
   }

   protected int getTabLabelShiftY(int var1, int var2, boolean var3) {
      return 0;
   }

   private void FwRs(Graphics var1, Font var2, FontMetrics var3, int var4, String var5, Rectangle var6, boolean var7, boolean var8) {
      var1.setFont(var2);
      if(this.tabPane.isEnabled() && this.tabPane.isEnabledAt(var4)) {
         Color var9 = var7?this.KRBh():(var8?this.Wczh:this.Gwbn());
         var1.setColor(var9);
         var1.drawString(var5, var6.x, var6.y + var3.getAscent());
      } else {
         var1.setColor(this.tabPane.getBackgroundAt(var4).brighter());
         var1.drawString(var5, var6.x, var6.y + var3.getAscent());
         var1.setColor(this.tabPane.getBackgroundAt(var4).darker());
         var1.drawString(var5, var6.x - 1, var6.y + var3.getAscent() - 1);
      }
   }

   protected void installDefaults() {
      super.installDefaults();
      this.tabAreaInsets = new Insets(4, 4, 4, 4);
      this.tabInsets = new Insets(0, 12, 0, 14);
      this.contentBorderInsets = new Insets(0, 0, 0, 0);
      this.tabRunOverlay = -2;
      this.InuZ = new Color(80, 80, 80);
      this.Gwbn = new Color(255, 255, 255, 179);
      this.VdwQ = new Color(162, 162, 162);
      this.hndF = new Color(162, 162, 162);
      this.Wczh = Color.white;
      this.KRBh = Color.white;
      this.eOaK = new Color(132, 132, 132);
      this.qkXP = new Color(144, 144, 144);
      this.Pbhj = new Color(128, 128, 128);
      this.HliR = new Color(182, 182, 182);
      this.WDwv = this.HliR;
      this.ZcdI = new Color(218, 218, 218);
      this.rMou = new Color(237, 237, 237);
      this.uHxD = new Color(49, 49, 51);
      this.PvrW = new Color(49, 49, 51);
   }

   protected void setRolloverTab(int var1) {
      int var2 = this.getRolloverTab();
      super.setRolloverTab(var1);
      if(var2 != var1) {
         var2 = this.tabPane.getTabPlacement();
         int var3 = this.tabPane.getWidth();
         int var4 = this.tabPane.getHeight();
         Insets var5 = this.tabPane.getInsets();
         Rectangle var10001;
         switch(var2) {
         case 2:
            var10001 = new Rectangle(var5.left, var5.top, this.calculateTabAreaWidth(var2, this.runCount, this.maxTabHeight), var4 - var5.top - var5.bottom);
            break;
         case 3:
            var1 = this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
            var2 = var4 - var5.bottom - var1;
            var10001 = new Rectangle(var5.left, var2, var3 - var5.right - var5.left, var1);
            break;
         case 4:
            var1 = this.calculateTabAreaWidth(var2, this.runCount, this.maxTabHeight);
            var10001 = new Rectangle(var3 - var5.right - var1, var5.top, var1, var4 - var5.top - var5.bottom);
            break;
         default:
            var1 = this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
            var10001 = new Rectangle(var5.left, var5.top, var3 - var5.right - var5.left, var1);
         }

         this.tabPane.repaint(var10001);
      }

   }

   private Color GSXJ() {
      return this.HliR;
   }

   private Color InuZ() {
      return UIUtils.GSXJ((JComponent)this.tabPane)?(TVov.FwRs(this.tabPane)?this.Pbhj:this.qkXP):this.WDwv;
   }

   private Color Gwbn() {
      return TVov.FwRs(this.tabPane)?(UIUtils.GSXJ((JComponent)this.tabPane)?this.Gwbn:this.hndF):(UIUtils.GSXJ((JComponent)this.tabPane)?this.InuZ:this.VdwQ);
   }

   private Color Wczh() {
      return this.Wczh;
   }

   private Color KRBh() {
      return UIUtils.GSXJ((JComponent)this.tabPane)?this.KRBh:this.eOaK;
   }

   private Color VdwQ() {
      return TVov.FwRs(this.tabPane)?this.uHxD:this.ZcdI;
   }

   private Color hndF() {
      return TVov.FwRs(this.tabPane)?this.PvrW:this.rMou;
   }

   private boolean eOaK() {
      return TVov.FwRs(this.tabPane);
   }

   private boolean HliR() {
      return UIUtils.GSXJ((JComponent)this.tabPane);
   }
}
